# Coveo AuthenticationProvider Component (CoveoAuthenticationProvider)

The `AuthenticationProvider` component makes it possible to execute queries with an identity that the end user can obtain using an authentication provider configured on the Coveo REST Search API (see Claims Authentication).

When necessary, this component handles redirecting the browser to the address that starts the authentication process.

You can use the `data-tab` attribute to enable the `AuthenticationProvider` component only for the tabs of your search interface that require authentication (see the `Tab` component).

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- caption
- name
- showIFrame
- useIFrame

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### caption

caption: string

- Defined in ui/AuthenticationProvider/AuthenticationProvider.ts :70

Specifies the display name of the authentication provider. This is the name that you want to appear in the user interface when the end user is logging in.

Default value is the `name` option value.

Markup configuration example(s) :

    data-caption='foo'

### name

name: string

- Defined in ui/AuthenticationProvider/AuthenticationProvider.ts :62

Specifies the name of the authentication provider.

See SAML Authentication.

Markup configuration example(s) :

    data-name='foo'

### showIFrame

showIFrame: boolean

- Defined in ui/AuthenticationProvider/AuthenticationProvider.ts :96

If the `useIFrame` option is `true`, specifies whether to make the authentication `<iframe>` visible to the user (inside a popup).

When the underlying authentication provider requires no user interaction (for example, when a user authenticates using Windows authentication along with SharePoint claims), setting this option to `false` reduces the visual impact of the authentication process.

Default value is `true`.

Only effective when

  `useIFrame` is truthy

Default

  `true`

Markup configuration example(s) :

    data-show-i-frame='true'
    data-show-i-frame='false'

### useIFrame

useIFrame: boolean

- Defined in ui/AuthenticationProvider/AuthenticationProvider.ts :81

Specifies whether to use an `<iframe>` to host the chain of redirection that make up the authentication process.

Using an `<iframe>` prevents leaving the search page as part of the authentication process. However, some login providers refuse to load in an `<iframe>`.

Default value is `false`.

Default

  `false`

Markup configuration example(s) :

    data-use-i-frame='true'
    data-use-i-frame='false'

## Constructors

### constructor

- new AuthenticationProvider(element: HTMLElement, options?: IAuthenticationProviderOptions, bindings?: IComponentBindings, _window?: Window): AuthenticationProvider

- Overwrites Component.constructor

  - Defined in ui/AuthenticationProvider/AuthenticationProvider.ts :104

  Creates a new `AuthenticationProvider` component.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### Default value options: IAuthenticationProviderOptions = {}

    The options for the `AuthenticationProvider` component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  - ##### Optional _window: Window

  #### Returns AuthenticationProvider